
// ---------------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////////
//
// Functions mainly used for development and debugging
//
///////////////////////////////////////////////////////////////////////////////////
// In the final version most of this code will be commented out and not compiled

void DebugReport(int zRPnn ) {
  ///////////////////////////////////////////////////////////////////////
  // a choice of print statements to inspect variables dynamically
  ///////////////////////////////////////////////////////////////////////
  // note at 4ms cycle and 115200 baud string length is limited to 46 chars
  // max in a 4ms period, otherwise blocking will occur. If used of WiFi then
  // link corruption may occur; so to prevent rogue values we send data twice and
  // checked on receive as a valid pair of duplicate values, otherwise disgard it.
  switch (zRPnn) {
    case 0:
      // Gyro angles and accelerometer angles
      if (RPT > 0) {
        // send data labels for display in PID Graph tool
        PrintTx += "##PitchGyr°,PitchAcc°,YawGyr°,YawAcc°\n";
      } else {
        // send data
        PrintTx += String(PitchGyr) + ",";
        PrintTx += String(PitchAcc) + ",";
        PrintTx += String(YawGyr) + ",";
        PrintTx += String(YawAcc) + "\n";
      } break;
    case 1:
      // Gyro Offsets
      if (RPT > 0) {
        // send data labels for display in PID Graph tool
        PrintTx += "##PitchGyr°,GyXOff,YawGyr°,GyYOff\n";
      } else {
        // send data
        PrintTx += String(PitchGyr) + ",";
        PrintTx += String(GyXOff) + ",";
        PrintTx += String(YawGyr) + ",";
        PrintTx += String(GyYOff) + "\n";
      } break;
    case 2:
      // Raw accelerometer angles
      if (RPT > 0) {
        // send data labels for display in PID Graph tool
        PrintTx += "##Raw AcX+Off,Raw AcY+Off,Raw AcZ+Off\n";
      } else {
        // send data
        PrintTx += String(AcX) + ",";
        PrintTx += String(AcY) + ",";
        PrintTx += String(AcZ) + "\n";
      } break;
    case 3:
      // LTOF ranges
      if (RPT > 0) {
        // send data labels for display in PID Graph tool
        PrintTx += "##Raw Range,Filtered Range\n";
      } else {
        // send data
        PrintTx += String(Range) + ",";
        PrintTx += String(RangeFtd) + "\n";
      } break;
    case 4:
      // Balance and topple
      if (RPT > 0) {
        // send data labels for display in PID Graph tool
        PrintTx += "##YawGyr,SBY,PitchGyr,SBP\n";
      } else {
        // send data
        PrintTx += String(YawGyr) + ",";
        PrintTx += String(SBY) + ",";
        PrintTx += String(PitchGyr) + ",";
        PrintTx += String(SBP) + "\n";
      } break;
    case 5:
      // Balance and topple
      if (RPT > 0) {
        // send data labels for display in PID Graph tool
        PrintTx += "##YawGyr,SBY,SBYErr,SBYInt\n";
      } else {
        // send data
        PrintTx += String(YawGyr) + ",";
        PrintTx += String(SBY) + ",";
        PrintTx += String(SBYErr) + ",";
        PrintTx += String(SBYInt) + "\n";
      } break;
    default:
      // handle the unexpected
      RPnn = 0; PrintTx += "RP0.\n"; break;
  }
}
